<template>
  <v-text-field
    v-model="field"
    :rules="syncValue !== null ? [validate] : []"
    :label="$t(`sync-field.label.${type}`)"
    :disabled="syncValue === null"
    @input="onInput"
    @keydown.exact.up="increment(1)"
    @keydown.exact.down="increment(-1)"
    @keydown.shift.up="increment(1, true)"
    @keydown.shift.down="increment(-1, true)"
  />
</template>

<script lang="ts">
import {
  Component, Prop, VModel, Vue, Watch,
} from 'vue-property-decorator';
import type {
  Onset, OnsetString, Signature,
} from '@/data';

export enum SyncFieldType {
  onset = 'onset',
  pixel = 'pixel',
  second = 'second',
  repeat = 'repeat',
}

@Component
export default class SyncField extends Vue {
  @VModel({ default: null })
  syncValue!: number | null;

  @Prop({ required: true })
  signature!: Signature;

  @Prop({ validator: (v: SyncFieldType) => Object.values(SyncFieldType).includes(v) })
  type!: SyncFieldType;

  increment(direction: number, isShift = false) {
    if (this.syncValue === null || this.lastOk === null) return;

    let increment: number = direction;

    switch (this.type) {
      case SyncFieldType.onset:
        increment *= isShift ? this.signature.measureIncrement : this.signature.increment;
        break;
      case SyncFieldType.pixel: increment *= isShift ? 10 : 1; break;
      case SyncFieldType.second: increment *= isShift ? 1 : 0.1; break;
      default:
    }

    const newTime = this.lastOk + increment;

    // Simulate input of new calculated syncValue
    this.onInput(this.print(newTime));
  }

  print(val: number): string {
    if (this.type === SyncFieldType.onset) return this.signature.printOnset(val as Onset);

    if (this.type === SyncFieldType.pixel) return val.toFixed(0);

    if (this.type === SyncFieldType.repeat) return val as unknown as string;

    return val.toFixed(2);
  }

  parse(val: string): number {
    if (this.type === SyncFieldType.repeat) return val as unknown as number;
    if (this.type === SyncFieldType.onset) {
      return this.signature.parseOnset(val as OnsetString);
    }

    if (this.type === SyncFieldType.pixel) {
      const parsed = Number.parseInt(val, 10);
      // Check width
      if (Number.isSafeInteger(parsed)) return parsed;

      throw new Error('Cannot parse value');
    }

    const parsed = Number.parseFloat(val);

    if (Number.isFinite(parsed)) return parsed;

    throw new Error('Cannot parse value');
  }

  /**
   * Contains current string value of the field
   */
  protected field = '';

  /**
   * Contains the last parsed value of the field
   * Used to prevent needless update of the field value
   */
  protected lastOk: number | null = null;

  mounted() {
    this.resetField();
  }

  // Watch a change of sync points (not internal change)
  @Watch('actions.selectCount')
  @Watch('value')
  onLabelChange() {
    this.resetField();
  }

  resetField() {
    // Initialize the field
    if (this.syncValue === null) {
      this.field = '';
      this.lastOk = null;
    } else if (this.syncValue !== this.lastOk) {
      this.lastOk = this.syncValue;
      this.field = this.print(this.syncValue as number);
    }
  }

  onInput(newFieldValue: string) {
    if (this.syncValue === null) return;

    try {
      // Make sure the field is up to date with the input
      this.field = newFieldValue;
      // Get the new value
      const newVal: number = this.parse(newFieldValue);

      // If something changed, change the sync point
      // Store in lastOk to avoid field being updated after this
      if (newVal !== this.lastOk) {
        this.syncValue = newVal;
        this.lastOk = newVal;
      }
    } catch (e) {
      // Ignore errors
      // If the field is not valid, vuetify will have called validate,
      // and an error message will have already appeared
    }
  }

  validate(str: string): true | string {
    try {
      this.parse(str);
      return true;
    } catch (e) {
      return (e as Error).message || `${str} is not valid`;
    }
  }

  public focus() {
    this.$el.querySelector('input')?.select();
  }
}
</script>
